#include "jidchanger.h"


JidChangerClass::JidChangerClass() {

}

int JidChangerClass::SetOldJid(string jid) {

  int x;
  int y;


  // Set what the old host name and the new host name are
  oldJid = jid;
  x = oldJid.find('@');
  y = oldJid.length();
  oldHost = oldJid.substr(x + 1, y - x - 1);
  oldUser = oldJid.substr(0, x);

  return SUCCESS;
}


int JidChangerClass::SetNewJid(string jid) {

  int x, y;

  newJid = jid;

  // Set what the new host name and the new host name are
  x = newJid.find('@');
  y = newJid.length();
  newHost = newJid.substr(x + 1, y - x - 1);
  newUser = newJid.substr(0, x);
  return SUCCESS;

}


int JidChangerClass::RenameUser() {



  string cmd;
  string  buffer;
  string  newBuffer;
  string  newUserFileName;

  int     oldHash;
  int     newHash;
  int     x;
  int     y;


  char mvcmd[2048];

  bool found = FALSE;

  struct stat s;


  // First check to make sure we have an oldJid and newJid
  if ((oldJid.length() <= 0) || (newJid.length() <= 0)) {
    return FAILURE;
  }

  // Get a listing of all user files in a temporary file

  cmd = "find . -name '*.xml' -type f -exec grep -l \"";
  cmd += oldUser;
  cmd += "\" {} \\; 1> ";
  cmd += FINDTEMP;

  PrintString("working...");
  system( cmd.c_str() );

  PrintString(".");

  // Go through the temporary file, one line at a time
  // open each user file and read a line at a time
  // search in each line for the old jid string
  // if not found, write the entire line out to new file
  // if found replace the old jid name with the new and write
  // line out to new file
  //
  inFindFile.open( FINDTEMP, ios::in );

  if (!inFindFile) {
    cerr << endl << "File could not be opened: " << FINDTEMP << endl;
    return FAILURE;
  }
  while (inFindFile >> userFileName ) {
    inUserFile.open ( (char *)userFileName.c_str(), ios::in );
    if (!inUserFile) {
      cerr << endl << "File could not be opened: " << userFileName << endl;
      return FAILURE;
    } else {
//       cout << "User File Opened" << endl;
    }
    newUserFileName = userFileName + ".new";

    outUserFile.open ( (char *)newUserFileName.c_str(), ios::out );

    if (!outUserFile) {
      cerr << endl << "File could not be opened: " <<newUserFileName << endl;
      return FAILURE;
    } else {
      PrintString(".");
//       cout << "New file opened" << endl;
    }
    found = false;
    while (inUserFile >> buffer ) {
      newBuffer = "";
      x = buffer.find( oldJid );
      y = 0;
      if (x != string::npos) {
	while (x != string::npos) {
	  found = true;
	  newBuffer += buffer.substr(y, x - y);
	  newBuffer += newJid;

	  y = x + oldJid.length();
	  x = buffer.find( oldJid, y);
	}
	newBuffer += buffer.substr(y);
	newBuffer += " ";
      } else {
	newBuffer += buffer;
	newBuffer += " ";
      }

      outUserFile << newBuffer;
      PrintString(".");
    }
    inUserFile.close();
    outUserFile.close();

    // When finished processing user file, replace the old user file
    // with the new user file
    //
    if (found) {
      cmd = "";
      cmd = "mv ";
      cmd += userFileName;
      cmd += " ";
      cmd += userFileName;
      cmd += ".old";
      system( cmd.c_str() );

      cmd = "";
      cmd = "mv ";
      cmd += newUserFileName;
      cmd += " ";
      cmd += userFileName;
      system( cmd.c_str() );
    } else {
      unlink(newUserFileName.c_str());
    }
  }
  PrintString(".");
  inFindFile.close();
  unlink(FINDTEMP);

  // Once done with the other users files, we need to rename
  // this users file.  If just the user's name has changed
  // then recalculate the hash directory that it should be in
  // and rename it.  If it is a different domain then also move
  // to that different domain.
  //
  // Get the oldUserName hash
  oldHash = calchash_func((char *)oldUser.c_str());
  if (newUser != oldUser) {
    // Calculate the new 0-999 hash
    newHash = calchash_func((char *)newUser.c_str());
  } else {
    newHash = oldHash;
  }

  PrintString(".");

  sprintf(mvcmd, "./%s/%d", newHost.c_str(), newHash);

  // ensure that the directory exists, or create it
  if( stat(mvcmd,&s) < 0 && mkdir(mvcmd, S_IRWXU) < 0) {
    cout << "request failed, error accessing spool location "<< mvcmd << endl;
    exit;
  }

  sprintf(mvcmd, "mv ./%s/%d/%s.xml ./%s/%d/%s.xml",
	  oldHost.c_str(), oldHash, oldUser.c_str(),
	  newHost.c_str(), newHash, newUser.c_str());

  system( mvcmd );

  return SUCCESS;

}

int JidChangerClass::ChangeTransportFiles() {


  string oldJidHash;
  string newJidHash;
  string oldFileName;
  string newFileName;
  string cmd;
  string path;
  int x;
  int newHash;
  int oldHash;

  char mvcmd[2048];
  struct stat s;


  // First check to make sure we have an oldJid and newJid
  if ((oldJid.length() <= 0) || (newJid.length() <= 0)) {
    return FAILURE;
  }

  // Check to see if we already have the sha hashed new and old jids
  if ((oldJidHash.length() <= 0) || (newJidHash.length() <= 0)) {
    oldJidHash = shahash((char *)oldJid.c_str());
    newJidHash = shahash((char *)newJid.c_str());

  }

  // Build the name of the file to look for
  oldFileName = oldJidHash;
  oldFileName += ".xml";


  newFileName = newJidHash;
  newFileName += ".xml";

  // Get a listing of all files with that name in a temporary file
  cmd = "find . -name ";
  cmd += oldFileName;
  cmd += " -type f 1> ";
  cmd += FINDTEMP;

  PrintString(".");
  system( cmd.c_str() );

  // Go through the temporary file, one line at a time
  // and rename each file to the new jid hash. 
  //
  inFindFile.open( FINDTEMP, ios::in );

  if (!inFindFile) {
    cerr << "File could not be opened: " << FINDTEMP << endl;
    return FAILURE;
  }
  while (inFindFile >> userFileName ) {

    // Get the path to this file so we can append it to the new
    // hash we calculated above
    x = userFileName.find_last_of('/');
    path = userFileName.substr(0, x);
    x = path.find_last_of('/');
    path = path.substr(0, x + 1);

    newHash = calchash_func((char *)newJidHash.c_str());

    PrintString(".");

    sprintf(mvcmd, "%s/%d", path.c_str(), newHash);

    // ensure that the directory exists, or create it
    if( stat(mvcmd,&s) < 0 && mkdir(mvcmd, S_IRWXU) < 0) {
      cout << "request failed, error accessing spool location "<< mvcmd << endl;
      return FAILURE;
    }

    sprintf(mvcmd, "mv %s %s/%d/%s", userFileName.c_str(),
	    path.c_str(), newHash, newFileName.c_str());

    system( mvcmd );
  }
  inFindFile.close();
  unlink(FINDTEMP);
  // MSN Gateway just uses the jid with % substituted instead of @
  // Get a listing of all files with that name in a temporary file
  newFileName = newUser;
  newFileName += "%";
  newFileName += newHost;

  cmd = "find . -name '";
  cmd += oldUser;
  cmd += "%";
  cmd += oldHost;
  cmd += ".xml' -type f 1> ";
  cmd += FINDTEMP;

  system( cmd.c_str() );

  // Go through the temporary file, one line at a time
  // and rename each file to the new jid hash. 
  //
  inFindFile.open( FINDTEMP, ios::in );

  if (!inFindFile) {
    cerr << "File could not be opened: " << FINDTEMP << endl;
    return FAILURE;
  }
  while (inFindFile >> userFileName ) {

    // Calculate the new 0-999 hash
    newFileName = newUser;
    newFileName += "%";
    newFileName += newHost;

    newHash = calchash_func((char *)newFileName.c_str());

    // Get the path to this file so we can append it to the new
    // hash we calculated above
    x = userFileName.find_last_of('/');
    path = userFileName.substr(0, x);
    x = path.find_last_of('/');
    path = path.substr(0, x + 1);

    PrintString(".");

    sprintf(mvcmd, "%s/%d", path.c_str(), newHash);

    // ensure that the directory exists, or create it
    if( stat(mvcmd,&s) < 0 && mkdir(mvcmd, S_IRWXU) < 0) {
      cout << "request failed, error accessing spool location "<< mvcmd << endl;
      return FAILURE;
    }

    cmd = "mv ";
    cmd += userFileName;
    cmd += " ";
    cmd += path;
    cmd += newHash;
    cmd += "/'";
    cmd += newFileName;
    cmd += ".xml'";



    system(cmd.c_str());
  }
  inFindFile.close();
  unlink(FINDTEMP);

  cout << endl;

  return SUCCESS;
}

void JidChangerClass::PrintString(char *x) {

  cout << x << flush;
}

int JidChangerClass::CopyUser() {



  string cmd;
  string  buffer;
  string  newBuffer;
  string  newUserFileName;

  int     oldHash;
  int     newHash;
  int     x;
  int     y;


  char mvcmd[2048];

  bool found = FALSE;

  struct stat s;


  // First check to make sure we have an oldJid and newJid
  if ((oldJid.length() <= 0) || (newJid.length() <= 0)) {
    return FAILURE;
  }

  // If just the user's name has changed
  // then recalculate the hash directory that it should be in
  // and rename it.  If it is a different domain then also move
  // to that different domain.
  //
  // Get the oldUserName hash
  oldHash = calchash_func((char *)oldUser.c_str());
  if (newUser != oldUser) {
    // Calculate the new 0-999 hash
    newHash = calchash_func((char *)newUser.c_str());
  } else {
    newHash = oldHash;
  }

  PrintString(".");

  sprintf(mvcmd, "./%s/%d", newHost.c_str(), newHash);

  // ensure that the directory exists, or create it
  if( stat(mvcmd,&s) < 0 && mkdir(mvcmd, S_IRWXU) < 0) {
    cout << "request failed, error accessing spool location "<< mvcmd << endl;
    exit;
  }

  sprintf(mvcmd, "cp ./%s/%d/%s.xml ./%s/%d/%s.xml",
	  oldHost.c_str(), oldHash, oldUser.c_str(),
	  newHost.c_str(), newHash, newUser.c_str());

  system( mvcmd );

  return SUCCESS;

}

int JidChangerClass::CopyTransportFiles() {


  string oldJidHash;
  string newJidHash;
  string oldFileName;
  string newFileName;
  string cmd;
  string path;
  int x;
  int newHash;
  int oldHash;

  char mvcmd[2048];
  struct stat s;


  // First check to make sure we have an oldJid and newJid
  if ((oldJid.length() <= 0) || (newJid.length() <= 0)) {
    return FAILURE;
  }

  // Check to see if we already have the sha hashed new and old jids
  if ((oldJidHash.length() <= 0) || (newJidHash.length() <= 0)) {
    oldJidHash = shahash((char *)oldJid.c_str());
    newJidHash = shahash((char *)newJid.c_str());

  }

  // Build the name of the file to look for
  oldFileName = oldJidHash;
  oldFileName += ".xml";


  newFileName = newJidHash;
  newFileName += ".xml";

  // Get a listing of all files with that name in a temporary file
  cmd = "find . -name ";
  cmd += oldFileName;
  cmd += " -type f 1> ";
  cmd += FINDTEMP;

  PrintString(".");
  system( cmd.c_str() );

  // Go through the temporary file, one line at a time
  // and rename each file to the new jid hash. 
  //
  inFindFile.open( FINDTEMP, ios::in );

  if (!inFindFile) {
    cerr << "File could not be opened: " << FINDTEMP << endl;
    return FAILURE;
  }
  while (inFindFile >> userFileName ) {

    // Get the path to this file so we can append it to the new
    // hash we calculated above
    x = userFileName.find_last_of('/');
    path = userFileName.substr(0, x);
    x = path.find_last_of('/');
    path = path.substr(0, x + 1);

    newHash = calchash_func((char *)newJidHash.c_str());

    PrintString(".");

    sprintf(mvcmd, "%s/%d", path.c_str(), newHash);

    // ensure that the directory exists, or create it
    if( stat(mvcmd,&s) < 0 && mkdir(mvcmd, S_IRWXU) < 0) {
      cout << "request failed, error accessing spool location "<< mvcmd << endl;
      return FAILURE;
    }

    sprintf(mvcmd, "cp %s %s/%d/%s", userFileName.c_str(),
	    path.c_str(), newHash, newFileName.c_str());

    system( mvcmd );
  }
  inFindFile.close();
  unlink(FINDTEMP);
  // MSN Gateway just uses the jid with % substituted instead of @
  // Get a listing of all files with that name in a temporary file
  newFileName = newUser;
  newFileName += "%";
  newFileName += newHost;

  cmd = "find . -name '";
  cmd += oldUser;
  cmd += "%";
  cmd += oldHost;
  cmd += ".xml' -type f 1> ";
  cmd += FINDTEMP;

  system( cmd.c_str() );

  // Go through the temporary file, one line at a time
  // and rename each file to the new jid hash. 
  //
  inFindFile.open( FINDTEMP, ios::in );

  if (!inFindFile) {
    cerr << "File could not be opened: " << FINDTEMP << endl;
    return FAILURE;
  }
  while (inFindFile >> userFileName ) {

    // Calculate the new 0-999 hash
    newFileName = newUser;
    newFileName += "%";
    newFileName += newHost;

    newHash = calchash_func((char *)newFileName.c_str());

    // Get the path to this file so we can append it to the new
    // hash we calculated above
    x = userFileName.find_last_of('/');
    path = userFileName.substr(0, x);
    x = path.find_last_of('/');
    path = path.substr(0, x + 1);

    PrintString(".");

    sprintf(mvcmd, "%s/%d", path.c_str(), newHash);

    // ensure that the directory exists, or create it
    if( stat(mvcmd,&s) < 0 && mkdir(mvcmd, S_IRWXU) < 0) {
      cout << "request failed, error accessing spool location "<< mvcmd << endl;
      return FAILURE;
    }

    cmd = "cp ";
    cmd += userFileName;
    cmd += " ";
    cmd += path;
    cmd += newHash;
    cmd += "/'";
    cmd += newFileName;
    cmd += ".xml'";



    system(cmd.c_str());
  }
  inFindFile.close();
  unlink(FINDTEMP);

  cout << endl;

  return SUCCESS;
}
